// 005 u_math
// 30 jan 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

// -- remove the "Single"

(*$r+*)

unit u_math;
  interface
    uses SysUtils
        , u_c_basic_object;

    type EPowerException= class(Exception)
                          end;

    Function f_power(X, N: real): extended;

  implementation

    function f_power(X, N: real): extended;
      var t: longint;
          r: real;
          isInteger: boolean;
      begin
        if N= 0
          then
            begin
              result:= 1.0;
              exit;
            end;
        if X= 1.0
          then
            begin
              result:= 1.0;
              exit;
            end;
        if X= 0.0
          then
            begin
              if N> 0.0
                then
                  begin
                    result:= 0.0;
                    exit;
                  end
                else raise EPowerException.Create('Infinite Result');
            end;
        if (X> 0)
          then try
            result:= exp(N* ln(X));
            exit;
          except
            raise EPowerException.Create('Overflow/Underflow Result');
          end;
          { X is negative but we still may compute the result if n is an integer}
          { try and get integer portion of n into a longint, it will be quicker to}
          { compute odd n}
        try
          t:= trunc(n);
          if (n- t)= 0
            then isInteger:= true
            else isInteger:= False;
        except
          {Bit superfluous as result will probably underflow/overflow anyway}
          r:= int(n);
          if (n- r)= 0
            then
              begin
                isInteger:= true;
                if frac(r/ 2)= 0.5
                  then t:= 1
                  else t:= 2;
              end
            else
              begin
                t:= 0;
                isInteger:= False;
              end;
        end;
        if isInteger
          then
            begin {n is an integer}
              if odd(t)
                then {n is odd}
                try
                  result:= - exp(N* ln(- X));
                  exit;
                except
                  raise EPowerException.Create('Overflow/Underflow Result');
                end
                else {n is even}
                try
                  result:= exp(N* ln(- X));
                  exit;
                except
                  raise EPowerException.Create('Overflow/Underflow Result');
                end;
            end
          else raise EPowerException.Create('Complex Result');
      end; // f_power

    begin // u_c_yyy
    end. // u_c_yyy
